// VCSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCSample.h"
#include "VCSampleDlg.h"
#include "VaxVoIP.h"
#include "HelpDlg.h"
#include "Mmsystem.h"

#pragma comment(lib, "Winmm.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define GENERAL_TIMER_ID	0
#define VOL_LEVEL_TIMER_ID	1
#define TOTAL_NO_LINES		7
#define LIST_ITEM_POST_FIX	"                "

/////////////////////////////////////////////////////////////////////////////
// CVCSampleDlg dialog

CVCSampleDlg::CVCSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCSampleDlg)
	m_sProxyLoginId = _T("");
	m_sProxyLoginPwd = _T("");
	m_sProxyURI = _T("");
	m_sOutboundProxy = _T("");
	m_sPhoneNumber = _T("");
	m_bMicMute = FALSE;
	m_bSpkMute = FALSE;
	m_sWavFile = _T("");
	m_bStartRecording = FALSE;
	m_bEnableEchoNoiseCancel = TRUE;
	m_bEnableMicBoost = FALSE;
	m_bDonotDisturb = FALSE;
	m_bGSM610 = TRUE;
	m_biLBC = TRUE;
	m_bG711ALaw = TRUE;
	m_bG711ULaw = TRUE;
	m_bEnableAGC = FALSE;
	m_sPlayWaveFileName = _T("");
	m_bPlayListen = FALSE;
	m_sTransferPhoneNo = _T("");
	m_bPlayRingTone = TRUE;
	m_sProxyDisplayName = _T("");
	m_bCheckRegisterToProxy = TRUE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_pVaxVoIP = new CVaxVoIP;
	m_pVaxVoIP->m_pVCSampleDlg = this;

}


void CVCSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCSampleDlg)
	DDX_Control(pDX, IDC_CHECK_ENABLE_CONFERENCE, m_ctrlCheckStartConf);
	DDX_Control(pDX, IDC_CHECK_START_RECORDING, m_ctrlCheckStartRecord);
	DDX_Control(pDX, IDC_COMBO_AUDIO_IN, m_ctrlComboAudioIn);
	DDX_Control(pDX, IDC_COMBO_AUDIO_OUT, m_ctrlComboAudioOut);
	DDX_Control(pDX, IDC_LIST_LINES, m_ctrlLineList);
	DDX_Control(pDX, IDC_PROGRESS_MIC, m_ctrlMicProg);
	DDX_Control(pDX, IDC_PROGRESS_SPK, m_ctrlSpkProg);
	DDX_Control(pDX, IDC_LOG_LIST_BOX, m_ctrlStatusLogListBox);
	DDX_Control(pDX, IDC_LIST_INCOMING_CALLS, m_ctrlIncomingCallListBox);
	DDX_Control(pDX, IDC_LIST_INCOMING_CALLIDS, m_ctrlIncomingCalIIdListBox);
	DDX_Control(pDX, IDC_BUTTON_INIT, m_ctrlInitButton);
	DDX_Control(pDX, IDC_SLIDER_MIC, m_MicSlider);
	DDX_Control(pDX, IDC_SLIDER_SPEAKER, m_SpkSlider);
	DDX_Text(pDX, IDC_EDIT_PROXY_LOGIN_ID, m_sProxyLoginId);
	DDX_Text(pDX, IDC_EDIT_PROXY_LOGIN_PWD, m_sProxyLoginPwd);
	DDX_Text(pDX, IDC_EDIT_PROXY_URI, m_sProxyURI);
	DDX_Text(pDX, IDC_EDIT_OUTBOUND_PROXY, m_sOutboundProxy);
	DDX_Text(pDX, IDC_EDIT_PHONE_NUMBER, m_sPhoneNumber);
	DDX_Check(pDX, IDC_CHECK_MIC_MUTE, m_bMicMute);
	DDX_Check(pDX, IDC_CHECK_SPK_MUTE, m_bSpkMute);
	DDX_Text(pDX, IDC_EDIT_FILE_NAME, m_sWavFile);
	DDX_Check(pDX, IDC_CHECK_START_RECORDING, m_bStartRecording);
	DDX_Check(pDX, IDC_CHECK_ECHO, m_bEnableEchoNoiseCancel);
	DDX_Check(pDX, IDC_CHECK_MIC_BOOST, m_bEnableMicBoost);
	DDX_Check(pDX, IDC_CHECK_DONOT_DISTURB, m_bDonotDisturb);
	DDX_Check(pDX, IDC_CHECK_GSM610, m_bGSM610);
	DDX_Check(pDX, IDC_CHECK_ILBC, m_biLBC);
	DDX_Check(pDX, IDC_CHECK_G711ALAW, m_bG711ALaw);
	DDX_Check(pDX, IDC_CHECK_G711ULAW, m_bG711ULaw);
	DDX_Check(pDX, IDC_CHECK_AGC, m_bEnableAGC);
	DDX_Text(pDX, IDC_EDIT_PLAY_WAVE_FILE, m_sPlayWaveFileName);
	DDX_Check(pDX, IDC_CHECK_PLAY_WAVE_LISTEN, m_bPlayListen);
	DDX_Text(pDX, IDC_EDIT_TRANSFER_PHONE_NO, m_sTransferPhoneNo);
	DDX_Check(pDX, IDC_CHECK_PLAY_RING_TONE, m_bPlayRingTone);
	DDX_Text(pDX, IDC_EDIT_PROXY_DISPLAY_NAME, m_sProxyDisplayName);
	DDX_Check(pDX, IDC_CHECK_REGISTER_TO_SIP, m_bCheckRegisterToProxy);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CVCSampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_INIT, OnButtonInit)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_DIAL, OnButtonDial)
	ON_BN_CLICKED(IDC_BUTTON_ACCEPT, OnButtonAccept)
	ON_BN_CLICKED(IDC_BUTTON_REJECT, OnButtonReject)
	ON_BN_CLICKED(IDC_BUTTON_HANGUP, OnButtonHangup)
	ON_BN_CLICKED(IDC_BUTTON_1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON_2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON_3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON_4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON_5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON_6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON_7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON_8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON_9, OnButton9)
	ON_BN_CLICKED(IDC_BUTTON_10, OnButton10)
	ON_BN_CLICKED(IDC_BUTTON_11, OnButton11)
	ON_BN_CLICKED(IDC_BUTTON_12, OnButton12)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_CHECK_SPK_MUTE, OnCheckSpkMute)
	ON_BN_CLICKED(IDC_CHECK_MIC_MUTE, OnCheckMicMute)
	ON_BN_CLICKED(IDC_BUTTON_RESET_RECORDING, OnButtonResetRecording)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_TO_WAVE_FILE, OnButtonSaveToWaveFile)
	ON_BN_CLICKED(IDC_CHECK_START_RECORDING, OnCheckStartRecording)
	ON_BN_CLICKED(IDC_CHECK_ECHO, OnCheckEcho)
	ON_BN_CLICKED(IDC_CHECK_MIC_BOOST, OnCheckMicBoost)
	ON_BN_CLICKED(IDC_CHECK_DONOT_DISTURB, OnCheckDonotDisturb)
	ON_BN_CLICKED(IDC_CHECK_GSM610, OnCheckGsm610)
	ON_BN_CLICKED(IDC_CHECK_ILBC, OnCheckiLBC)
	ON_BN_CLICKED(IDC_CHECK_G711ALAW, OnCheckG711ALaw)
	ON_BN_CLICKED(IDC_CHECK_G711ULAW, OnCheckG711ULaw)
	ON_BN_CLICKED(IDC_BUTTON_HELP, OnButtonHelp)
	ON_BN_CLICKED(IDC_BUTTON_TRANSFER_CALL, OnButtonTransferCall)
	ON_BN_CLICKED(IDC_CHECK_AGC, OnCheckAgc)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_WAVE, OnButtonOpenWave)
	ON_BN_CLICKED(IDC_BUTTON_WAVE_PLAY, OnButtonWavePlay)
	ON_BN_CLICKED(IDC_BUTTON_WAVE_REWIND, OnButtonWaveRewind)
	ON_BN_CLICKED(IDC_BUTTON_WAVE_FORWARD, OnButtonWaveForward)
	ON_BN_CLICKED(IDC_BUTTON_WAVE_PAUSE, OnButtonWavePause)
	ON_BN_CLICKED(IDC_BUTTON_WAVE_STOP, OnButtonWaveStop)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_PLAY_RING_TONE, OnCheckPlayRingTone)
	ON_BN_CLICKED(IDC_CHECK_ENABLE_CONFERENCE, OnCheckEnableConference)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCSampleDlg message handlers

BOOL CVCSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_SpkSlider.SetRange(0,10);
	m_MicSlider.SetRange(0,10);
	
	m_ctrlSpkProg.SetRange(0, 100);
	m_ctrlMicProg.SetRange(0, 100);

	m_ctrlSpkProg.SetPos(0);
	m_ctrlMicProg.SetPos(0);

	m_ctrlComboAudioOut.SetWindowPos(NULL,0,0,157,100,SWP_NOMOVE|SWP_NOZORDER);
	m_ctrlComboAudioIn.SetWindowPos(NULL,0,0,157,100,SWP_NOMOVE|SWP_NOZORDER);
			
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

void CVCSampleDlg::OnOK() 
{
	// TODO: Add extra validation here
	//CDialog::OnOK();
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CVCSampleDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if((CSliderCtrl*)pScrollBar == &m_SpkSlider)
	{
		if(TB_THUMBTRACK)
		{
			/***************************************************************
			SetSpkVolume method requires Volume value from 0 to 255 range    
			but the slider range is 0 to 10, so we multiply the slider value 
			to 25 to get the required value to pass to SetSpkVolume method   

							For more detail, please see the method details document
			*****************************************************************/
			
			m_pVaxVoIP->SetSpkVolume(m_SpkSlider.GetPos()	* 25);
		}

	}
	
	
	if((CSliderCtrl*)pScrollBar == &m_MicSlider)
	{
		if(TB_THUMBTRACK)
		{
			/***************************************************************
			SetMicVolume method requires Volume value from 0 to 255 range    
			but the slider range is 0 to 10, so we multiply the slider value 
			to 25 to get the required value to pass to SetMicVolume method   

							For more detail, please see the method details document
			*****************************************************************/
			
			m_pVaxVoIP->SetMicVolume(m_MicSlider.GetPos()	* 25);
		}

	}
		
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


void CVCSampleDlg::OnButtonInit() 
{
	CString sInitBtnText = "";
	m_ctrlInitButton.GetWindowText(sInitBtnText);

	if(sInitBtnText == "Offline")
	{
		m_ctrlInitButton.SetWindowText("Online");
		m_pVaxVoIP->UnInitialize();

		KillTimer(VOL_LEVEL_TIMER_ID);
		KillTimer(GENERAL_TIMER_ID);

		m_ctrlSpkProg.SetPos(0);
		m_ctrlMicProg.SetPos(0);

		return;
	}

	
	UpdateData();
			
	if(m_sProxyLoginId.IsEmpty())
	{
		MessageBox("Please enter the SIP proxy Login Id.", "SIP Proxy settings", MB_OK|MB_ICONEXCLAMATION);
		return;
	}

	if(m_sProxyURI.IsEmpty())
	{
		MessageBox("Please enter the SIP proxy address or URI.", "SIP Proxy settings", MB_OK|MB_ICONEXCLAMATION);
		return;
	}

	m_pVaxVoIP->SetLicenceKey("TRIAL-LICENSE-KEY");
	
		
	/***** Constructing SIP From URI for IP Telephony ***********/
	
	CString sFromURI = "";
	
	if(m_sProxyDisplayName.IsEmpty())
		sFromURI.Format("%s <sip:%s@%s>", m_sProxyLoginId, m_sProxyLoginId, m_sProxyURI);
	else
		sFromURI.Format("%s <sip:%s@%s>", m_sProxyDisplayName, m_sProxyLoginId, m_sProxyURI);
	
	/********************************************************************
			 
		SIP Proxy: SIP Proxy IP or FQDN provided by your service provider.
  
		OutboundProxy: SIP outbound/NAT proxy IP or FQDN provided by your 
		             service provider to use SIP phone behind the NAT.

	*********************************************************************/	
 
	CString sMyIP = m_pVaxVoIP->GetMyIP();
	
	BOOL bResult = FALSE;
	int nListenPortSIP = 0;

	for(nListenPortSIP = 5060; nListenPortSIP < 7000; nListenPortSIP++)
	{
		bResult = m_pVaxVoIP->Initialize(FALSE, sMyIP, nListenPortSIP, sFromURI, m_sOutboundProxy, m_sProxyURI, m_sProxyLoginId, m_sProxyLoginPwd, TRUE, TOTAL_NO_LINES);
		
		if(!bResult)
		{
			if(m_pVaxVoIP->GetVaxObjectError() != 11)
			{
				m_pVaxVoIP->ErrorMessage();
				break;
			}
		}
		else
		{
			break;
		}
	}

	if(nListenPortSIP >= 7000)
	{
		MessageBox("Cann't open SIP communication port.");
		return;
	}
	
	if(bResult == TRUE)
	{
		int nListenPortRTP = 7000;

		int nErrorCount = 0;
		
		for(int nLineNo = 0; nLineNo < TOTAL_NO_LINES; nLineNo++)
		{
			if(!m_pVaxVoIP->OpenLine(nLineNo, FALSE, sMyIP, nListenPortRTP))
			{
				if(m_pVaxVoIP->GetVaxObjectError() == 11)
				{
					nErrorCount++;
					nLineNo--;
				}
				else
				{
					m_pVaxVoIP->ErrorMessage();
					bResult = FALSE;
					break;
				}
			}
		
			nListenPortRTP += 2;  // It is importent to increament RTP Listen Port by 2

			if(nErrorCount >= (TOTAL_NO_LINES + 1000)) // If unable to open more than 1000 ports.
			{	
				MessageBox("Unable to open RTP communication port.");
				return;
			}
		
		}
	}
	
	if(bResult == TRUE)
	{
		if(m_bCheckRegisterToProxy)
		{
			if(!m_pVaxVoIP->RegisterToProxy(3600))
			{
				m_pVaxVoIP->ErrorMessage();
				return;
			}

			AddToStatusList("Registering to SIP Proxy.");
		}

		m_pVaxVoIP->EnableKeepAlive(10);
				
		if(m_bEnableEchoNoiseCancel)
			m_pVaxVoIP->EnableEchoNoiseCancellation();
		else
			m_pVaxVoIP->DisableEchoNoiseCancellation();
												
		
		m_pVaxVoIP->DeselectAllVoiceCodec();
		
		if(m_bGSM610)
			m_pVaxVoIP->SelectVoiceCodec(0);
		
		if(m_biLBC)
			m_pVaxVoIP->SelectVoiceCodec(1);

		if(m_bG711ALaw)
			m_pVaxVoIP->SelectVoiceCodec(2);

		if(m_bG711ULaw)
			m_pVaxVoIP->SelectVoiceCodec(3);
				
		m_ctrlInitButton.SetWindowText("Offline");
		
		FillAudioComboBoxes();

		SetTimer(GENERAL_TIMER_ID, 1000, 0);
		SetTimer(VOL_LEVEL_TIMER_ID, 20, NULL);
	}

}


void CVCSampleDlg::FillAudioComboBoxes()
{
	m_ctrlComboAudioOut.ResetContent();
	m_ctrlComboAudioOut.AddString("Default Device");

	int nDeviceId = 0;
	
	for(nDeviceId = 0; nDeviceId < m_pVaxVoIP->GetAudioOutDevTotal(); nDeviceId++)
		m_ctrlComboAudioOut.AddString(m_pVaxVoIP->GetAudioOutDevName(nDeviceId));
	
	m_ctrlComboAudioOut.SetCurSel(0);

	m_ctrlComboAudioIn.ResetContent();
	m_ctrlComboAudioIn.AddString("Default Device");

	for(nDeviceId = 0; nDeviceId < m_pVaxVoIP->GetAudioInDevTotal(); nDeviceId++)
		m_ctrlComboAudioIn.AddString(m_pVaxVoIP->GetAudioInDevName(nDeviceId));
	
	m_ctrlComboAudioIn.SetCurSel(0);
}

void CVCSampleDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	delete m_pVaxVoIP;
}

void CVCSampleDlg::OnButtonClear() 
{
	m_ctrlStatusLogListBox.ResetContent();
}

void CVCSampleDlg::OnButtonDial() 
{
	UpdateData();

	if(m_sPhoneNumber.IsEmpty())
	{
		MessageBox("Please enter a phone number.", "Invalid phone number", MB_OK|MB_ICONEXCLAMATION);
		return;
	}

	/*******************************************************
         Constructing SIP To URI for IP Telephony:
                  sip:PhoneNumber@SIP Proxy
  ********************************************************/
	
	CString sToURI = "sip:" + m_sPhoneNumber + "@" + m_sProxyURI;

	int nLineNo = FindLine();
	if(nLineNo == -1) 
	{
		MessageBox("No line is free", "VaxVoIP", MB_OK);
		return;
	}

	if(!m_pVaxVoIP->Connect(nLineNo, sToURI, GetSelectedAudioInDeviceId(), GetSelectedAudioOutDeviceId()))
	{
		m_pVaxVoIP->ErrorMessage();
	}
	else
	{
		CString sText = "";
		sText.Format("Line-%d: Dialing.", nLineNo + 1);
		
		AddToStatusList(sText);
				
		m_ctrlLineList.SetItemState(nLineNo, LVIS_SELECTED, LVIS_SELECTED);
		
		sText.Format("Line-%d  :  CONNECTING", nLineNo + 1);
		m_ctrlLineList.SetItemText(nLineNo, 0, sText + LIST_ITEM_POST_FIX);
	}
	
}


void CVCSampleDlg::OnButtonHangup() 
{
	int nLineNo = GetLineListSelectedItem();
	
	if(!m_pVaxVoIP->Disconnect(nLineNo))
		m_pVaxVoIP->ErrorMessage();
		
}

void CVCSampleDlg::OnButtonAccept() 
{
	CString sCallId = GetSelectedItemCallId();
	if(sCallId.IsEmpty()) return;
		
	int nLineNo = FindLine();
	if(nLineNo == -1) MessageBox("No line is free", "VaxVoIP", MB_OK);
		
	if(!m_pVaxVoIP->AcceptCall(nLineNo, sCallId, GetSelectedAudioInDeviceId(), GetSelectedAudioOutDeviceId()))
	{
		m_pVaxVoIP->ErrorMessage();
	}
	else
	{
		
		StopTone();
		
		int nIndex = m_ctrlIncomingCalIIdListBox.FindString(-1, sCallId);
		if(nIndex != -1)
		{
			m_ctrlIncomingCallListBox.DeleteString(nIndex);
			m_ctrlIncomingCalIIdListBox.DeleteString(nIndex);
		}

		if(m_ctrlIncomingCallListBox.GetCurSel() == -1)
			m_ctrlIncomingCallListBox.SetCurSel(0);

		CString sText;
		sText.Format("Line-%d  :  CONNECTING", nLineNo + 1);
		m_ctrlLineList.SetItemState(nLineNo, LVIS_SELECTED, LVIS_SELECTED);
	}
}


void CVCSampleDlg::OnButtonReject() 
{		
	CString sCallId = GetSelectedItemCallId();
	if(sCallId.IsEmpty()) return;
			
	if(!m_pVaxVoIP->RejectCall(sCallId))
	{
		m_pVaxVoIP->ErrorMessage();
	}
	else
	{
		StopTone();
		
		int nIndex = m_ctrlIncomingCalIIdListBox.FindString(-1, sCallId);
		if(nIndex != -1)
		{
			m_ctrlIncomingCallListBox.DeleteString(nIndex);
			m_ctrlIncomingCalIIdListBox.DeleteString(nIndex);
		}

		if(m_ctrlIncomingCallListBox.GetCurSel() == -1)
			m_ctrlIncomingCallListBox.SetCurSel(0);
	}
}


void CVCSampleDlg::OnButton1() 
{
	UpdateData();
	
	m_sPhoneNumber += "1";
	
	m_pVaxVoIP->DigitDTMF(GetLineListSelectedItem(), "1");
	
	UpdateData(FALSE);
	
}

void CVCSampleDlg::OnButton2() 
{
	UpdateData();
	
	m_sPhoneNumber += "2";
	m_pVaxVoIP->DigitDTMF(GetLineListSelectedItem(), "2"); 
	
	UpdateData(FALSE);
	
}

void CVCSampleDlg::OnButton3() 
{
	UpdateData();
	
	m_sPhoneNumber += "3";
	m_pVaxVoIP->DigitDTMF(GetLineListSelectedItem(), "3");
	
	UpdateData(FALSE);
}

void CVCSampleDlg::OnButton4() 
{
	UpdateData();
	
	m_sPhoneNumber += "4";
	m_pVaxVoIP->DigitDTMF(GetLineListSelectedItem(), "4");
	
	UpdateData(FALSE);
}

void CVCSampleDlg::OnButton5() 
{
	UpdateData();
	
	m_sPhoneNumber += "5";
	m_pVaxVoIP->DigitDTMF(GetLineListSelectedItem(), "5");
	
	UpdateData(FALSE);
}

void CVCSampleDlg::OnButton6() 
{
	UpdateData();
	
	m_sPhoneNumber += "6";
	m_pVaxVoIP->DigitDTMF(GetLineListSelectedItem(), "6");
	
	UpdateData(FALSE);
}

void CVCSampleDlg::OnButton7() 
{
	UpdateData();
	
	m_sPhoneNumber += "7";
	m_pVaxVoIP->DigitDTMF(GetLineListSelectedItem(), "7");
	
	UpdateData(FALSE);
}

void CVCSampleDlg::OnButton8() 
{
	UpdateData();
	
	m_sPhoneNumber += "8";
	m_pVaxVoIP->DigitDTMF(GetLineListSelectedItem(), "8");
	
	UpdateData(FALSE);
}

void CVCSampleDlg::OnButton9() 
{
	UpdateData();
	
	m_sPhoneNumber += "9";
	m_pVaxVoIP->DigitDTMF(GetLineListSelectedItem(), "9");
	
	UpdateData(FALSE);
}

void CVCSampleDlg::OnButton11() 
{
	UpdateData();
	
	m_sPhoneNumber += "0";
	m_pVaxVoIP->DigitDTMF(GetLineListSelectedItem(), "0");
	
	UpdateData(FALSE);
}

void CVCSampleDlg::OnButton10() 
{
	m_pVaxVoIP->DigitDTMF(GetLineListSelectedItem(), "*");
}


void CVCSampleDlg::OnButton12() 
{
	m_pVaxVoIP->DigitDTMF(GetLineListSelectedItem(), "#");
}

void CVCSampleDlg::OnCheckSpkMute() 
{
	UpdateData();
	m_pVaxVoIP->MuteSpk(m_bSpkMute);
}

void CVCSampleDlg::OnCheckMicMute() 
{
	UpdateData();
	m_pVaxVoIP->MuteMic(m_bMicMute);
}

void CVCSampleDlg::OnButtonResetRecording() 
{
	int nLineNo = GetLineListSelectedItem();
	
	m_pVaxVoIP->ResetRecording(nLineNo);
}

void CVCSampleDlg::OnButtonSaveToWaveFile() 
{
	UpdateData();
	
	int nLineNo = GetLineListSelectedItem();

	if(!m_pVaxVoIP->SaveRecordingToWaveFile(nLineNo, m_sWavFile))
	{
		m_pVaxVoIP->ErrorMessage();
	}
	else
	{
		MessageBox("Saved successfully.", "VaxVoIP SIP SDK", MB_ICONINFORMATION|MB_OK);
	}
}

void CVCSampleDlg::OnCheckStartRecording() 
{
	UpdateData();

	int nLineNo = GetLineListSelectedItem();
		
	if(m_bStartRecording)
		m_pVaxVoIP->StartRecording(nLineNo, 2, TRUE);
	else
		m_pVaxVoIP->StopRecording(nLineNo);
}

void CVCSampleDlg::OnCheckEcho() 
{
	UpdateData();
	
	if(m_bEnableEchoNoiseCancel)
		m_pVaxVoIP->EnableEchoNoiseCancellation();
	else
		m_pVaxVoIP->DisableEchoNoiseCancellation();
}


void CVCSampleDlg::OnCheckMicBoost() 
{
	UpdateData();
	
	if(m_bEnableMicBoost)
		m_pVaxVoIP->EnableMicBoost();
	else
		m_pVaxVoIP->DisableMicBoost();
}


void CVCSampleDlg::OnCheckDonotDisturb() 
{
	UpdateData();
	
	if(m_bDonotDisturb)
		m_pVaxVoIP->EnableDonotDisturb();
	else
		m_pVaxVoIP->DisableDonotDisturb();	
}


void CVCSampleDlg::OnCheckGsm610() 
{
	/**** Codec No 0 represents GSM 6.10 *****/
	
	UpdateData();
	
	if(m_bGSM610)
		m_pVaxVoIP->SelectVoiceCodec(0);
	else
		m_pVaxVoIP->DeselectVoiceCodec(0);	
}

void CVCSampleDlg::OnCheckiLBC() 
{
	/**** Codec No 1 represents iLBC ********/
	
	UpdateData();
	
	if(m_biLBC)
		m_pVaxVoIP->SelectVoiceCodec(1);
	else
		m_pVaxVoIP->DeselectVoiceCodec(1);
	
}

void CVCSampleDlg::OnCheckG711ALaw() 
{
	/**** Codec No 2 represents GSM711 A-Law *****/
	
	UpdateData();
		
	if(m_bG711ALaw)
		m_pVaxVoIP->SelectVoiceCodec(2);
	else
		m_pVaxVoIP->DeselectVoiceCodec(2);

}

void CVCSampleDlg::OnCheckG711ULaw() 
{
	/**** Codec No 3 represents GSM711 U-Law *****/
	
	UpdateData();
		
	if(m_bG711ULaw)
		m_pVaxVoIP->SelectVoiceCodec(3);
	else
		m_pVaxVoIP->DeselectVoiceCodec(3);
}

void CVCSampleDlg::OnButtonHelp() 
{
	CHelpDlg HelpDlg;
	HelpDlg.DoModal();
}


void CVCSampleDlg::OnButtonTransferCall() 
{
	UpdateData();

	CString sToURI = "sip:" + m_sTransferPhoneNo + "@" + m_sProxyURI;
	
	int nLineNo = GetLineListSelectedItem();
	
	if(!m_pVaxVoIP->TransferCall(nLineNo, sToURI))
	{
		m_pVaxVoIP->ErrorMessage();
	}
}

void CVCSampleDlg::OnCheckAgc() 
{
	UpdateData();
	
	if(m_bEnableAGC)
	{
		m_pVaxVoIP->EnableAGC(8000);
	}
	else
	{
		m_pVaxVoIP->DisableAGC();
	}
}


void CVCSampleDlg::OnButtonOpenWave() 
{
	UpdateData();

	int nLineNo = GetLineListSelectedItem();
	
	if(!m_pVaxVoIP->PlayWaveOpen(nLineNo, m_sPlayWaveFileName))
	{
		m_pVaxVoIP->ErrorMessage();
	}
}

void CVCSampleDlg::OnButtonWavePlay() 
{
	UpdateData();
	
	int nLineNo = GetLineListSelectedItem();
	
	if(!m_pVaxVoIP->PlayWaveStart(nLineNo, m_bPlayListen))
	{
		m_pVaxVoIP->ErrorMessage();
	}
}

void CVCSampleDlg::OnButtonWaveRewind() 
{
	int nLineNo = GetLineListSelectedItem();
	
	int nPlayPos = m_pVaxVoIP->PlayWavePosition(nLineNo);

	if(nPlayPos == -1)
	{
		m_pVaxVoIP->ErrorMessage();
		return;
	}

	if(!m_pVaxVoIP->PlayWaveSkipTo(nLineNo, nPlayPos - 3))
	{
		m_pVaxVoIP->ErrorMessage();
	}
}

void CVCSampleDlg::OnButtonWaveForward() 
{
	int nLineNo = GetLineListSelectedItem();
	
	int nPlayPos = m_pVaxVoIP->PlayWavePosition(nLineNo);

	if(nPlayPos == -1)
	{
		m_pVaxVoIP->ErrorMessage();
		return;
	}
	
	if(!m_pVaxVoIP->PlayWaveSkipTo(nLineNo, nPlayPos + 3))
	{
		m_pVaxVoIP->ErrorMessage();
	}
	
}

void CVCSampleDlg::OnButtonWavePause() 
{
	int nLineNo = GetLineListSelectedItem();
	
	if(!m_pVaxVoIP->PlayWavePause(nLineNo))
	{
		m_pVaxVoIP->ErrorMessage();
	}
}

void CVCSampleDlg::OnButtonWaveStop() 
{
	int nLineNo = GetLineListSelectedItem();
	
	if(!m_pVaxVoIP->PlayWaveStop(nLineNo))
	{
		m_pVaxVoIP->ErrorMessage();
	}
}

CString CVCSampleDlg::GetSelectedItemCallId()
{
	
	int nSelectedItemIndex = m_ctrlIncomingCallListBox.GetCurSel();
	if(nSelectedItemIndex == -1) return "";

	CString sCallId = "";
	
	m_ctrlIncomingCalIIdListBox.GetText(nSelectedItemIndex, sCallId);

	return sCallId;
}

void CVCSampleDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == GENERAL_TIMER_ID)
	{
		UpdateLineStatus();
	}
	else if(nIDEvent == VOL_LEVEL_TIMER_ID)
	{
		m_ctrlSpkProg.SetPos(m_pVaxVoIP->GetSpkSoundLevel());
		m_ctrlMicProg.SetPos(m_pVaxVoIP->GetMicSoundLevel());
	}
	
	CDialog::OnTimer(nIDEvent);
}


int CVCSampleDlg::GetLineListSelectedItem()
{
	POSITION pos = m_ctrlLineList.GetFirstSelectedItemPosition();
	if(pos == NULL) return -1;

	return m_ctrlLineList.GetNextSelectedItem(pos);
}

int CVCSampleDlg::FindLine()
{
	int nLineNo = GetLineListSelectedItem();
	if(nLineNo == -1)	return -1;

	if(!m_pVaxVoIP->IsLineBusy(nLineNo)) return nLineNo;

	for(nLineNo = 0; nLineNo < TOTAL_NO_LINES; nLineNo++)
	{
		if(!m_pVaxVoIP->IsLineBusy(nLineNo)) return nLineNo;
	}

	return -1;
}

void CVCSampleDlg::UpdateLineList(int nLineNo)
{
	if(m_ctrlCheckStartConf.GetCheck() == BST_CHECKED)
	{
		for(int nLineCount = 0; nLineCount < TOTAL_NO_LINES; nLineCount++)
		{
			if(m_pVaxVoIP->IsLineHold(nLineCount))
				m_pVaxVoIP->UnHoldLine(nLineCount);
		}
	}
		
	else
	{
		for(int nLineCount = 0; nLineCount < TOTAL_NO_LINES; nLineCount++)
		{
			if(nLineCount == nLineNo) continue;
		
			if(m_pVaxVoIP->IsLineBusy(nLineCount) == TRUE && m_pVaxVoIP->IsLineHold(nLineCount) == FALSE) 
			{
				m_pVaxVoIP->HoldLine(nLineCount);
			}
		}
	
		if(m_pVaxVoIP->IsLineHold(nLineNo))
			m_pVaxVoIP->UnHoldLine(nLineNo);
	}
}	

void CVCSampleDlg::UpdateLineStatus()
{
	int nLineNo = 0;
	
	if(m_ctrlLineList.GetItemCount() == 0)
	{
		for(nLineNo = 0; nLineNo < TOTAL_NO_LINES; nLineNo++)
		{
			CString sString = "";
			sString.Format("Line-%d  :  FREE                ", nLineNo + 1);
		
			m_ctrlLineList.InsertItem(nLineNo, sString);
		}

		m_ctrlLineList.SetItemState(0, LVIS_SELECTED, LVIS_SELECTED);
	}

	nLineNo = GetLineListSelectedItem();
	UpdateLineList(nLineNo);
						
	if((m_ctrlCheckStartRecord.GetCheck() == BST_CHECKED) != m_pVaxVoIP->IsRecording(nLineNo))
	{
		if(m_pVaxVoIP->IsRecording(nLineNo))
			m_ctrlCheckStartRecord.SetCheck(BST_CHECKED);
		else m_ctrlCheckStartRecord.SetCheck(BST_UNCHECKED);
	}

	for(int nItemNo = 0; nItemNo < m_ctrlLineList.GetItemCount(); nItemNo++)
	{
		CString sItemStatus = "";
		sItemStatus.Format("Line-%d  :  ", nItemNo + 1);
	
		CString sItemText = m_ctrlLineList.GetItemText(nItemNo, 0);

		if(!m_pVaxVoIP->IsLineOpen(nItemNo))
		{
			if(sItemText.Find("CLOSE") == -1)
			{						
				m_ctrlLineList.SetItemText(nItemNo, 0, sItemStatus + "CLOSE" + LIST_ITEM_POST_FIX);
			}
		}
		else if(m_pVaxVoIP->IsLineBusy(nItemNo))
		{
			if(m_pVaxVoIP->IsWaveFilePlaying(nItemNo))
			{
				if(sItemText.Find("PLAYING") == -1)
				{							
					m_ctrlLineList.SetItemText(nItemNo, 0, sItemStatus + "PLAYING" + LIST_ITEM_POST_FIX);
				}
			}
			else if(m_pVaxVoIP->IsLineHold(nItemNo))
			{
				if(sItemText.Find("HOLD") == -1)
				{							
					m_ctrlLineList.SetItemText(nItemNo, 0, sItemStatus + "HOLD" + LIST_ITEM_POST_FIX);
				}
			}
			else
			{
				if(sItemText.Find("BUSY") == -1 && sItemText.Find("CONNECTING") == -1)
				{							
					m_ctrlLineList.SetItemText(nItemNo, 0, sItemStatus + "BUSY" + LIST_ITEM_POST_FIX);
				}
			}
		}
		else
		{
			if(sItemText.Find("FREE") == -1)
			{							
				m_ctrlLineList.SetItemText(nItemNo, 0, sItemStatus + "FREE" + LIST_ITEM_POST_FIX);
			}
		}
	}
}

void CVCSampleDlg::OnSuccessToConnect(int nLineNo)
{
	if(nLineNo != GetLineListSelectedItem())
	{
		m_pVaxVoIP->HoldLine(nLineNo);

		CString sItemStatus = "";
		sItemStatus.Format("Line-%d  :  ", nLineNo + 1);

		m_ctrlLineList.SetItemText(nLineNo, 0, sItemStatus + "HOLD" + LIST_ITEM_POST_FIX);
	}
	else
	{
		CString sItemStatus = "";
		sItemStatus.Format("Line-%d  :  ", nLineNo + 1);
		m_ctrlLineList.SetItemText(nLineNo, 0, sItemStatus + "BUSY" + LIST_ITEM_POST_FIX);
	}
	
	int nVol = m_pVaxVoIP->GetMicVolume();
	m_MicSlider.SetPos(nVol/25);

	nVol = m_pVaxVoIP->GetSpkVolume();
	m_SpkSlider.SetPos(nVol/25);
	
	m_bEnableMicBoost = m_pVaxVoIP->IsMicBoostEnable();

	UpdateData(FALSE);
}


void CVCSampleDlg::OnIncomingCall(LPCTSTR sCallId, LPCTSTR sCLI)
{
	if(m_ctrlIncomingCalIIdListBox.FindString(-1, sCallId) != -1)
		return;
	
	m_ctrlIncomingCallListBox.AddString(sCLI);
	m_ctrlIncomingCalIIdListBox.AddString(sCallId);

	if(m_ctrlIncomingCallListBox.GetCurSel() == -1)
		m_ctrlIncomingCallListBox.SetCurSel(0);
}


void CVCSampleDlg::OnIncomingCallRingingStart(LPCTSTR sCallId)
{
	UpdateData();
	
	if(m_bPlayRingTone)
		StartTone();
}


void CVCSampleDlg::OnIncomingCallRingingStop(LPCTSTR sCallId)
{
	StopTone();
		
	int nIndex = m_ctrlIncomingCalIIdListBox.FindString(-1, sCallId);
	if(nIndex != -1)
	{
		m_ctrlIncomingCallListBox.DeleteString(nIndex);
		m_ctrlIncomingCalIIdListBox.DeleteString(nIndex);
	}

	if(m_ctrlIncomingCallListBox.GetCurSel() == -1)
		m_ctrlIncomingCallListBox.SetCurSel(0);
}


void CVCSampleDlg::OnCheckPlayRingTone() 
{
	UpdateData();
		
	if(!m_bPlayRingTone)
	{
		StopTone();
	}
}


void CVCSampleDlg::AddToStatusList(LPCTSTR sText)
{
	m_ctrlStatusLogListBox.AddString(sText);
	m_ctrlStatusLogListBox.SetTopIndex(m_ctrlStatusLogListBox.GetCount() - 1);
}


int CVCSampleDlg::GetSelectedAudioInDeviceId()
{
	return m_ctrlComboAudioOut.GetCurSel() - 1;
}

int CVCSampleDlg::GetSelectedAudioOutDeviceId()
{
	return m_ctrlComboAudioOut.GetCurSel() - 1;
}

void CVCSampleDlg::StartTone()
{
	::PlaySound(MAKEINTRESOURCE(IDR_WAVE_RING), AfxGetInstanceHandle(), SND_RESOURCE|SND_ASYNC|SND_LOOP|SND_NODEFAULT);
}

void CVCSampleDlg::StopTone()
{
	::PlaySound(NULL, AfxGetInstanceHandle(), SND_PURGE);
}


void CVCSampleDlg::OnCheckEnableConference() 
{
	int nBusyCount = 0;
	
	for(int nLineNo = 0; nLineNo < TOTAL_NO_LINES; nLineNo++)
	{
		if(m_pVaxVoIP->IsLineBusy(nLineNo))
			nBusyCount++;
	}

	if(nBusyCount < 2)
	{
		m_ctrlCheckStartConf.SetCheck(BST_UNCHECKED);
		MessageBox("Dial/receive more than one calls and then click start conference check box.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
	}
}
