// VaxSIPUserAgentLib.h: interface for the CVaxSIPUserAgentLib class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VAXSIPUSERAGENTLIB_H__A370F557_2178_4F9E_8B8C_8C2554A94C55__INCLUDED_)
#define AFX_VAXSIPUSERAGENTLIB_H__A370F557_2178_4F9E_8B8C_8C2554A94C55__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CVaxSIPUserAgentObject;

class CVaxSIPUserAgentLib  
{
public:
	CVaxSIPUserAgentLib();
	~CVaxSIPUserAgentLib();

private:

	CVaxSIPUserAgentObject* m_pVaxSIPUserAgentObject;

public:

	int GetMicSoundLevel();
	int GetSpkSoundLevel();

	int GetAudioInDevTotal();
	int GetAudioOutDevTotal();

	LPCTSTR GetAudioOutDevName(int nDeviceId);
	LPCTSTR GetAudioInDevName(int nDeviceId);

	BOOL Initialize(BOOL bBindToListenIP, LPCTSTR sListenIP, UINT nListenPort, LPCTSTR sFromURI, LPCTSTR sSIPOutBoundProxy, LPCTSTR sSIPProxy, LPCTSTR sLoginId, LPCTSTR sLoginPwd, BOOL bUseSoundDevice, int nTotalLine);
	void UnInitialize();

	BOOL RegisterToProxy(int nExpire);
	BOOL UnRegisterToProxy();
	
	BOOL OpenLine(int nLineNo, BOOL bBindToRTPRxIP, LPCTSTR sRTPRxIP, UINT nRTPRxPort);
	BOOL CloseLine(int nLineNo);

	BOOL SetLicenceKey(LPCTSTR sLicenceKey);
	DWORD GetVaxObjectError();
				
	BOOL Connect(int nLineNo, LPCTSTR sToURI, int nInputDeviceId, int nOutputDeviceId);
	BOOL Disconnect(int nLineNo);

	BOOL AcceptCall(int nLineNo, LPCTSTR sCallId, int nInputDeviceId, int nOutputDeviceId);
	BOOL RejectCall(LPCTSTR sCallId);
	
	BOOL TransferCall(int nLineNo, LPCTSTR sToURI);
	BOOL JoinTwoLine(int nLineNoA, int nLineNoB);
	
	BOOL HoldLine(int nLineNo);
	BOOL UnHoldLine(int nLineNo);
	
	BOOL IsLineOpen(int nLineNo);
	BOOL IsLineHold(int nLineNo);
	BOOL IsLineBusy(int nLineNo);
	
	BOOL EnableKeepAlive(int nSeconds);
	void DisableKeepAlive();

	void DeselectAllVoiceCodec();
	void SelectAllVoiceCodec();
	BOOL SelectVoiceCodec(int nCodecNo);
	BOOL DeselectVoiceCodec(int nCodecNo);

	LPCTSTR GetMyIP();
	
	BOOL DigitDTMF(int nLineNo, LPCTSTR sDigit);
	BOOL SetDTMFVolume(int nVolume);
	int GetDTMFVolume();

	BOOL EnableForceInbandDTMF(int nLineNo);
	BOOL DisableForceInbandDTMF(int nLineNo);

	BOOL MuteMic(BOOL bMute);
	BOOL MuteSpk(BOOL bMute);
	
	int GetMicVolume();
	BOOL SetMicVolume(int nVolume);
	int GetSpkVolume();
	BOOL SetSpkVolume(int nVolume);

	BOOL EnableMicBoost();
	BOOL DisableMicBoost();
	BOOL IsMicBoostEnable();

	BOOL EnableAGC(int nLevel);
	BOOL DisableAGC();
	
	BOOL EnableEchoNoiseCancellation();
	BOOL DisableEchoNoiseCancellation();

	BOOL IsRecording(int nLineNo);
	BOOL StartRecording(int nLineNo, int nRecordVoice, BOOL bRecordCompress);
	BOOL StopRecording(int nLineNo);
	BOOL ResetRecording(int nLineNo);
	BOOL SaveRecordingToWaveFile(int nLineNo, LPCTSTR sFileName);

	BOOL IsWaveFilePlaying(int nLineNo);
	BOOL PlayWaveOpen(int nLineNo, LPCTSTR sFileName);
	BOOL PlayWaveSkipTo(int nLineNo, int nSeconds);
	int PlayWaveTotalTime(int nLineNo);
	BOOL PlayWavePause(int nLineNo);
	BOOL PlayWaveStart(int nLineNo, BOOL bListen);
	BOOL PlayWaveStop(int nLineNo);
	int PlayWavePosition(int nLineNo);

	void EnableDonotDisturb();
	void DisableDonotDisturb();

	BOOL SetTOS(int nLineNo, int nValue);
	int GetTOS(int nLineNo);

	int GetOutboundCodec(int nLineNo);
	int GetInboundCodec(int nLineNo);

	LPCTSTR GetVersionFile();
	LPCTSTR GetVersionSDK();

	virtual void OnTryingToRegister();
	virtual void OnFailToRegister();
	virtual void OnSuccessToRegister();

	virtual void OnTryingToReRegister();
	virtual void OnFailToReRegister();
	virtual void OnSuccessToReRegister();
	
	virtual void OnTryingToUnRegister();
	virtual void OnFailToUnRegister();
	virtual void OnSuccessToUnRegister();
		
	virtual void OnConnecting(int nLineNo);
	virtual void OnSuccessToConnect(int nLineNo, LPCTSTR sToRTPIP, UINT nToRTPPort);
	virtual void OnFailToConnect(int nLineNo);
		
	virtual void OnDisconnectCall(int nLineNo);
	virtual void OnCallTransferAccepted(int nLineNo);
	virtual void OnPlayWaveDone(int nLineNo);
	virtual void OnDTMFDigit(int nLineNo, LPCTSTR sDigit);
	
	virtual void OnMsgNOTIFY(LPCTSTR sMsg);
	virtual void OnVoiceMailMsg(BOOL bIsMsgWaiting, DWORD dwNewMsgCount, DWORD dwOldMsgCount, DWORD dwNewUrgentMsgCount, DWORD dwOldUrgentMsgCount, LPCTSTR sMsgAccount);

	virtual void OnIncomingCall(LPCTSTR sCallId, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sFromURI, LPCTSTR sToURI);
	virtual void OnIncomingCallRingingStart(LPCTSTR sCallId);
	virtual void OnIncomingCallRingingStop(LPCTSTR sCallId);
		
	virtual void OnProvisionalResponse(int nLineNo, int nStatusCode, LPCTSTR sReasonPhrase);
	virtual void OnRedirectionResponse(int nLineNo, int nStatusCode, LPCTSTR sReasonPhrase, LPCTSTR sContact);
	virtual void OnRequestFailureResponse(int nLineNo, int nStatusCode, LPCTSTR sReasonPhrase);
	virtual void OnServerFailureResponse(int nLineNo, int nStatusCode, LPCTSTR sReasonPhrase);
	virtual void OnGeneralFailureResponse(int nLineNo, int nStatusCode, LPCTSTR sReasonPhrase);

	virtual void OnIncomingDiagnostic(LPCTSTR sMsgSIP, LPCTSTR sFromIP, UINT nFromPort);
	virtual void OnOutgoingDiagnostic(LPCTSTR sMsgSIP, LPCTSTR sToIP, UINT nToPort);
		
};

#endif // !defined(AFX_VAXSIPUSERAGENTLIB_H__A370F557_2178_4F9E_8B8C_8C2554A94C55__INCLUDED_)
